package com.example.firestoreexample

import android.content.Intent
import android.nfc.Tag
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.widget.Toast
import androidx.constraintlayout.solver.widgets.Snapshot
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.*
import com.google.firebase.firestore.FirebaseFirestore
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.activity_main.email
import kotlinx.android.synthetic.main.activity_main.username
import kotlinx.android.synthetic.main.activity_welcome.*

class welcome : AppCompatActivity() {

    private var mFirebaseDatabaseInstance:FirebaseFirestore?=null
    private var userId:String?=null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_welcome)

        mFirebaseDatabaseInstance= FirebaseFirestore.getInstance()

        val user=FirebaseAuth.getInstance().currentUser

        //add it only if it is not saved to database
        if (user != null) {
            userId=user.uid
            Log.e(TAG,"User data is null")
        }
        getDataOneTime()
    }
    private fun getDataOneTime(){

        //getting the data onetime
        val docRef=mFirebaseDatabaseInstance?.collection("users")?.document(userId!!)

        docRef?.get()?.addOnSuccessListener { documentSnapshot ->
            val user=documentSnapshot.toObject(user::class.java)

            Log.e(TAG,"user data is changed"+user?.name+", "+user?.email)

            //Display newly updated name and email
            txt_user.setText(user?.name+", "+user?.email)

            //Clear edit text
            email.setText(user?.email)
            username.setText(user?.name)
        }
    }
    fun onLogout(view: View) {
        FirebaseAuth.getInstance().signOut()
        startActivity(Intent(this, MainActivity::class.java))
    }

    private fun updateUser(name: String, email: String) {
        // updating the user via child nodes
        if (!TextUtils.isEmpty(name) && !TextUtils.isEmpty(email)) {
            val myRef = mFirebaseDatabaseInstance?.collection("users")?.document(userId!!)
            myRef!!.update("name", name)
            myRef.update("email", email)
            Toast.makeText(applicationContext, "Successfully updated user", Toast.LENGTH_SHORT)
                .show()
        } else
            Toast.makeText(applicationContext, "Unable to update user", Toast.LENGTH_SHORT).show()
    }

    fun onUpdateClicked(view: View) {
        val name = username.getText().toString()
        val email = email.getText().toString()

        updateUser(name, email)
        getDataOneTime()
    }

    fun onDeleteClicked(view: View) {
        mFirebaseDatabaseInstance!!.collection("users").document(userId!!).delete()
            .addOnSuccessListener { Toast.makeText(applicationContext, "Successfully deleted user", Toast.LENGTH_SHORT).show() }
            .addOnFailureListener { Toast.makeText(applicationContext, "Unable to delete user", Toast.LENGTH_SHORT).show() }

        // clear information
        txt_user.setText("")
        email.setText("")
        username.setText("")
        FirebaseAuth.getInstance().signOut()
        startActivity(Intent(this, MainActivity::class.java))
    }
    companion object{
        private val TAG=welcome::class.java.simpleName
    }


}
